# Script that automatically creates different versions of a routine with different precisions

# Import classes and functions from RPE_Utils
#from AutoRPE.UtilsRPE.MainFunctions import parse_sources, postprocess_sources, assign_sbits_to_rpe_variables, \
#    create_read_precisions_module_and_add_to_file, preprocess_sources
#from AutoRPE.UtilsRPE.Functions import load_vault, load_list_of_files_to_keep_unmodified, in_which_block, remove_comments, close_brackets, calls_to_routines, find_call_arguments, is_keyword_argument, match_arguments_and_interface
#from AutoRPE.UtilsRPE.CodeTools import replace_real_declaration, merge_lines
#from AutoRPE.UtilsRPE.Classes import Interface
#from os import listdir, mkdir
#from os.path import join, isdir, isfile, basename
#from shutil import rmtree
#import re
#from math import factorial
#import itertools
from AutoRPE.UtilsRPE.CodeTools import fix_casts    

if __name__ == "__main__":
    # Getting Command line options
    from optparse import OptionParser
    help_text = """
    """
    parser = OptionParser(usage=help_text)
    parser.add_option("-l", "--variable-list", dest="variable_list",
                     help="Path to the filename with the list of variables.", default=None, metavar="FILE")
    parser.add_option("-v", "--vault", dest="vault", default=None, metavar="FILE")
    parser.add_option("-s", "--input-source", dest="input_source", default=None, metavar="FILE")

    (options, args) = parser.parse_args()
    vault_path = options.vault
    source_path = options.input_source
    list_filename = options.variable_list



    if source_path is None or vault_path is None:
       print("\nArgument -s/--input-source and -v/--vault are mandatory\n")
       parser.print_help()
       exit(1)
    fix_casts(source_path, vault_path, list_filename)
